723d9b2753cc28e4a7bad53a74a629032cd47cd4
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Fre Nov 24 21:24:22 CET 2006 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
17 [ -z "$PS1" ] && trap "" 2 3 11
18
19 # zsh stuff
20 iszsh(){
21 if [ -n "$ZSH_VERSION" ] ; then
22   return 0
23 else
24   return 1
25 fi
26 }
27 # avoid 'no matches found: ...'
28 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
29 # }}}
30
31 ### {{{ Utility Functions
32
33 # Simple shell grep
34 stringinfile(){
35   case "$(cat $2)" in *$1*) return 0;; esac
36   return 1
37 }
38
39 # same for strings
40 stringinstring(){
41   case "$2" in *$1*) return 0;; esac
42   return 1
43 }
44
45 # Reread boot command line; echo last parameter's argument or return false.
46 getbootparam(){
47   stringinstring " $1=" "$CMDLINE" || return 1
48   result="${CMDLINE##*$1=}"
49   result="${result%%[   ]*}"
50   echo "$result"
51   return 0
52 }
53
54 # Check boot commandline for specified option
55 checkbootparam(){
56   stringinstring " $1" "$CMDLINE"
57   return "$?"
58 }
59
60 checkvalue(){
61   if [ "$1" = "yes" ] ; then
62     return 0
63   else
64     return 1
65   fi
66 }
67
68 checkgrmlsmall(){
69   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
70 }
71
72 checkgrmlusb(){
73   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
74 }
75 ### }}}
76
77 # {{{ filesystems (proc, pts, sys) and fixes
78 mount_proc(){
79   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
80 }
81
82 mount_pts(){
83   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
84 }
85
86 mount_sys(){
87   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
88 }
89 # }}}
90
91 # {{{ Read in boot parameters
92 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
93 CMDLINE="$(cat /proc/cmdline)"
94 [ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
95 # }}}
96
97 # {{{ Check if we are running from the grml-CD or HD
98 INSTALLED=""
99 [ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
100
101 # testcd
102 TESTCD=""
103 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
104 # }}}
105
106 # {{{ source lsb-functions , color handling
107 if checkbootparam "nocolor"; then
108   RC_NOCOLOR=yes
109   . /etc/grml/lsb-functions
110   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
111 else
112   . /etc/grml/lsb-functions
113   . /etc/grml_colors
114 fi
115 # }}}
116
117 # {{{ debug
118 config_debug(){
119  if checkbootparam "debug"; then
120    BOOTDEBUG="yes"
121  fi
122  if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
123    BOOTDEBUG="yes"
124  fi
125  rundebugshell(){
126   if [ -n "$BOOTDEBUG" ]; then
127     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
128     eindent
129     if [ -r /etc/grml/screenrc ] ; then
130        einfo "Starting GNU screen to be able to use a full featured shell environment."
131        einfo "Just exit the shells (and therefore screen) to continue boot process..."
132        /bin/zsh -c "screen -c /etc/grml/screenrc"
133     else
134       einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
135       einfo "Just exit the shell to continue boot process..."
136       /bin/zsh
137     fi
138     eoutdent
139   fi
140  }
141 }
142 # }}}
143
144 # {{{ log
145 config_log(){
146 if checkbootparam "log"; then
147   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
148   touch $DEBUG
149   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
150   eindent
151     einfo "Starting bootlogd."
152     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
153   eoutdent
154 else
155   DEBUG="/dev/null"
156 fi
157 }
158 # }}}
159
160 # {{{ Check if we are in interactive startup mode
161 INTERACTIVE=""
162 stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
163 # }}}
164
165 # {{{ set firmware timeout via bootparam
166 config_fwtimeout(){
167  if checkbootparam fwtimeout ; then
168    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
169    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
170    rmmod firmware_class 1>>$DEBUG 2>&1
171    modprobe firmware_class ; eend $?
172  fi
173  if [ -z "$TIMEOUT" ] ; then
174    TIMEOUT="100" # linux kernel default: 10
175  fi
176  if [ -f /sys/class/firmware/timeout ] ; then
177    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
178    echo 100 > /sys/class/firmware/timeout ; eend $?
179  fi
180 }
181 # }}}
182
183 ### {{{ language configuration / localization
184 config_language(){
185
186  einfo "Activating language settings:"
187  eindent
188
189  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
190  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
191
192  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
193
194  # check for bootoption which overrides config from /etc/grml/autoconfig:
195  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
196  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
197
198  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
199  if [ -z "$INSTALLED" ] ; then
200     [ -n "$LANGUAGE" ] || LANGUAGE='en'
201  fi
202
203  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
204  if [ -n "$BOOT_LANGUAGE" ] ; then
205     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
206  fi
207
208  # set console font
209  if [ -z "$CONSOLEFONT" ] ; then
210     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
211        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
212        if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
213           CONSOLEFONT='Lat15-Terminus16'
214        else
215           ewarn "/usr/share/consolefonts/Lat15-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
216        fi
217     fi
218  fi
219
220  # export it now, so error messages get translated, too
221  if checkgrmlsmall ; then
222     export LANG='C' # grml-small does not provide any further locales
223  else
224     [ -r /etc/default/locale ] && . /etc/default/locale
225     export LANG LANGUAGE
226  fi
227
228  # configure keyboard layout, read in already set values first:
229  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
230
231  # now allow keyboard override by boot commandline for later use:
232  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
233  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
234  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
235  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
236  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
237
238  # modify /etc/sysconfig/keyboard only in live-cd mode:
239  if [ -z "$INSTALLED" ] ; then
240
241    local LANGUAGE="$BOOT_LANGUAGE"
242    . /etc/grml/language-functions
243    # allow setting xkeyboard explicitly different than console keyboard
244    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
245    if [ -n "$KXKEYBOARD" ]; then
246       XKEYBOARD="$KXKEYBOARD"
247       KDEKEYBOARD="$KXKEYBOARD"
248    elif [ -n "$KKEYBOARD" ]; then
249       XKEYBOARD="$KKEYBOARD"
250       KDEKEYBOARD="$KKEYBOARD"
251    fi
252
253    # duplicate of previous code to make sure /etc/grml/language-functions
254    # does not overwrite our values....
255    # now allow keyboard override by boot commandline for later use:
256    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
257    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
258    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
259    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
260    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
261
262    # write keyboard related variables to file for later use
263    echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
264    echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
265    echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
266    echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
267  fi
268
269  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
270
271   # Set default keyboard before interactive setup
272   if [ -n "$KEYTABLE" ] ; then
273    einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
274    loadkeys -q $KEYTABLE &
275    eend $?
276   fi
277
278   if [ -n "$CONSOLEFONT" ] ; then
279      einfo "Running consolechars using ${CONSOLEFONT}"
280      consolechars -f $CONSOLEFONT || consolechars -d
281      eend $?
282
283      if [ -n "$UTF8" ] ; then
284         einfo "Notice: run 'filterm - dynafont' in your shell to enable a unicode capable console."
285      fi
286   fi
287
288   # we have to set up all consoles, therefore loop it over all ttys:
289   if [ -n "$CHARMAP" ] ; then
290    einfo "Running consolechars for ${CHARMAP}"
291    NUM_CONSOLES=`fgconsole --next-available`
292    NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
293    [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
294    for vc in `seq 0 ${NUM_CONSOLES}`  ; do
295      consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
296    done
297    eend ${RC}
298   fi
299
300  eoutdent
301 }
302 # }}}
303
304 # {{{ Set hostname
305 config_hostname(){
306  if checkbootparam hostname ; then
307   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
308   einfo "Setting hostname to $HOSTNAME as requested."
309   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
310   hostname $HOSTNAME ; eend $?
311  else
312   hostname --file /etc/hostname
313  fi
314 }
315 # }}}
316
317 # fstabuser (needed when running from harddisk with username != grml {{{
318 config_userfstab(){
319   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
320   if [ -n "$CONFIG_FSTAB_USER" ] ; then
321      fstabuser="$CONFIG_FSTAB_USER"
322   else
323      fstabuser=$(getent passwd 1000 | cut -d: -f1)
324   fi
325   # if not yet set fall back to default 'grml' user
326   [ -n "$fstabuser" ] || fstabuser='grml'
327 }
328 # }}}
329
330 # {{{ Set clock (Local time is more often used than GMT, so it is default)
331 config_time(){
332  # don't touch the files if running from harddisk:
333  if [ -z "$INSTALLED" ]; then
334   UTC=""
335   checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
336   checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
337   # hwclock uses the TZ variable
338   export TZ
339   hwclock $UTC -s
340  fi
341 }
342 # }}}
343
344 # {{{ print kernel info
345 config_kernel(){
346   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMWare${NORMAL}"
347   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
348 }
349 # }}}
350
351 # {{{ vmware specific stuff
352 config_vmware(){
353 if checkbootparam novmware ; then
354  ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
355 else
356  if [ -z "$INSTALLED" ]; then
357   if vmware-detect ; then
358     if [ -r /etc/X11/xorg.conf.vmware ] ; then
359       einfo "Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
360       cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
361     fi
362   fi
363  fi
364 fi
365 }
366 # }}}
367
368 # {{{ ld.so.cache + depmod
369 config_ld_mod(){
370 if [ -n "$INSTALLED" ]; then
371  if ! [ -r /etc/grml.first.boot ] ; then
372   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
373   eindent
374 # Regenerate ld.so.cache and module dependencies on HD
375     einfo "Running ldconfig" ; ldconfig  ; eend $?
376     einfo "Running depmod"   ; depmod -a ; eend $?
377     touch /etc/grml.first.boot
378     eend 0
379   eoutdent
380  fi
381 fi
382 }
383 # }}}
384
385 # update_progress {{{
386 update_progress(){
387   # be sure we are non-blocking
388   (echo "$1" > /etc/sysconfig/progress) &
389 }
390 # }}}
391
392 # {{{ timezone
393 config_timezone(){
394  # don't touch the files if running from harddisk:
395  if [ -z "$INSTALLED" ]; then
396   einfo "Setting timezone."
397   KTZ="$(getbootparam tz 2>>$DEBUG)"
398   [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
399   rm -f /etc/localtime
400   cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
401  fi
402 }
403 # }}}
404
405 # small computer / nearly no ram {{{
406 config_small(){
407
408 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
409 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
410 eindent
411
412 if checkbootparam "small"; then
413   einfo "Information: ${RAM} kB of RAM available." ; eend 0
414   einfo "Bootoption small detected. Activating small system."
415   if [ -r /etc/inittab.small ] ; then
416     mv /etc/inittab /etc/inittab.normal
417     mv /etc/inittab.small /etc/inittab
418   else
419     sed -i 's/^9/#&/' /etc/inittab
420     sed -i 's/^10/#&/' /etc/inittab
421     sed -i 's/^11/#&/' /etc/inittab
422     sed -i 's/^12/#&/' /etc/inittab
423   fi
424   /sbin/telinit q ; eend $?
425 else
426   if checkgrmlsmall ; then
427     if [[ $RAM -lt 25000 ]] ; then
428       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
429       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
430       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
431       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
432       /bin/zsh --login
433     else
434       einfo "Information: ${RAM} kB of RAM available." ; eend 0
435     fi
436   else
437     if [[ $RAM -lt 58000 ]] ; then
438       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
439       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
440       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
441       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
442       /bin/zsh --login
443     else
444       einfo "Information: ${RAM} kB of RAM available." ; eend 0
445     fi
446   fi
447 fi
448 eoutdent
449 }
450 # }}}
451
452 # skip startup of w3m {{{
453 config_fast(){
454 if checkbootparam "fast"; then
455   ewarn "Bootoption fast detected. Skipping startup of w3m."
456     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
457   /sbin/telinit q ; eend $?
458 fi
459 }
460 # }}}
461
462 # activate serial console {{{
463 config_console(){
464 if checkbootparam "console"; then
465   einfo "Bootoption (for serial) console detected. Activating mgetty."
466     sed -i 's/^#T0/T0/' /etc/inittab
467     sed -i 's/^#T1/T1/' /etc/inittab
468   /sbin/telinit q ; eend $?
469 fi
470 }
471 # }}}
472
473 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
474 config_cdrom_perm(){
475 CDROMS=""
476 for DEVICE in /proc/ide/hd?; do
477  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
478 done
479 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
480 }
481 # }}}
482
483 # {{{ Bring up loopback interface now
484 config_local_net(){
485  if [ -z "$INSTALLED" ] ; then
486     grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
487  fi
488 }
489 # }}}
490
491 # firewire devices {{{
492 # the raw1394 driver does not yet export info into SYSFS,
493 # so let's create raw1394 device manually
494 # http://www.michael-prokop.at/blog/index.php?p=352
495 config_firewire_dev(){
496 if checkbootparam "nofirewiredev" ; then
497   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
498 else
499 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
500   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
501 #  cd /dev && MAKEDEV video1394 raw1394
502   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
503   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
504 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
505   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
506   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
507   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
508 fi
509 #fi
510 }
511 # }}}
512
513 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
514 # otherwise we will get: passwd: Authentication token lock busy
515 config_fix_passwd(){
516  if [ -z "$INSTALLED" ] ; then
517   touch /etc/.pwd.lock
518  fi
519 }
520 # }}}
521
522 # {{{ CD Checker
523 config_testcd(){
524 if [ -n "$TESTCD" ]; then
525   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
526   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
527   echo -n "${RED}"
528   ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
529   if [ "$?" = "0" ]; then
530     echo " ${GREEN}Everything looks OK${NORMAL}"
531     else
532     echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
533     egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
534     echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
535     echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
536     echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
537     read a
538   fi
539   eend 0
540 fi
541 }
542 # }}}
543
544 # {{{ hardware detection via discover
545 config_discover(){
546 if checkbootparam "nodisc" ; then
547   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
548 else
549  if [ -x /sbin/discover ] ; then
550   einfo "Discovering hardware. Trying to load the following modules in background:"
551    eindent
552    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
553    eoutdent
554   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
555   eend 0
556  else
557   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
558  fi
559 fi
560 }
561 # }}}
562
563 # {{{ hardware detection via hwinfo
564 config_hwinfo(){
565 if checkbootparam hwinfo >>$DEBUG 2>&1; then
566   einfo "Discovering hardware via hwinfo:"
567   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
568   echo -n "  Loading modules: "
569   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
570   eend 0
571 fi
572 }
573 # }}}
574
575 # {{{ disable hotplug agents on request
576 config_hotplug_agent(){
577 if checkbootparam "noagent" ; then
578   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
579   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
580   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
581   einfo "Disabling hotplug-agent(s) $AGENTNL"
582   for agent in $(echo -e $AGENTLIST) ; do
583     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
584   done
585   [ "$?" == "0" ] ; eend $?
586 fi
587 }
588 # }}}
589
590 # {{{ blacklist of hotplug-modules
591 config_hotplug_blacklist(){
592 if checkbootparam "black" ; then
593   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
594   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
595   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
596   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
597   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
598   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
599   eend 0
600 fi
601 }
602 # }}}
603
604 # {{{ run hotplug
605 config_hotplug(){
606 if checkbootparam "nohotplug" ; then
607   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
608 else
609   if [ -r /etc/init.d/hotplug ] ; then
610     einfo "Starting hotplug system in background."
611     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
612     eend 0
613   elif [ -r /etc/init.d/hotplug-light ] ; then
614     einfo "Starting hotplug-light system in background."
615     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
616     eend 0
617   else
618     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
619   fi
620 fi
621 }
622 # }}}
623
624 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
625 config_blacklist(){
626 if checkbootparam "blacklist" ; then
627  if [ -z "$INSTALLED" ]; then
628   einfo "Bootoption blacklist found."
629   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
630   if [ -n "$BLACK" ] ; then
631     einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
632     echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
633     echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
634     echo "alias     $BLACK off" >> /etc/modprobe.d/grml
635     echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
636   else
637    eerror "No given module for blacklist found. Blacklisting will not work therefor."
638   fi
639  else
640   ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
641   eindent
642    einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
643   eoutdent
644  fi
645 fi
646 }
647 # }}}
648
649 # {{{ ACPI
650 config_acpi_apm(){
651 if [ -d /proc/acpi ]; then
652   if checkbootparam "noacpi"; then
653     ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
654   else
655     einfo "ACPI Bios found, activating modules: "
656     eindent
657     found=""
658     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
659       basename="${a##*/}"
660       basename="${basename%%.*}"
661       case "$basename" in *_acpi)
662        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
663       esac
664       modprobe $basename >>$DEBUG 2>&1 && found="yes"
665       local BASE="$BASE $basename"
666     done
667     if [ -n "$found" ] ; then
668       einfo "$BASE"  ; eend 0
669     else
670       ewarn "(none)" ; eend 1
671     fi
672     if ! [ -S /var/run/acpid.socket ] ; then
673       if ! [ -r /var/run/dbus/pid ] ; then
674         einfo "Starting acpi daemon."
675         /etc/init.d/acpid start >>$DEBUG ; eend $?
676       else
677         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
678         eerror "Solution: please activate acpid via /etc/runlevel.conf"
679         eend 1
680       fi
681     else
682       ewarn "acpi daemon already running."
683       eend 0
684     fi
685     eoutdent
686   fi
687 else
688 # APM
689   if checkbootparam "noapm"; then
690     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
691   else
692     modprobe apm power_off=1 >>$DEBUG 2>&1
693     if [ "$?" = "0" ] ; then
694        if [ -x /etc/init.d/apmd ] ;then
695           einfo "APM Bios found, enabling power management functions."
696           /etc/init.d/apmd start ; eend $?
697        fi
698     else
699       eerror "Loading apm module failed." ; eend 1
700     fi
701   fi
702 fi
703 }
704 # }}}
705
706 # {{{ PCMCIA Check/Setup
707 # This needs to be done before other modules are being loaded (by hwsetup)
708 config_pcmcia(){
709 if checkbootparam "nopcmcia"; then
710   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
711 else
712   if /usr/sbin/laptop-detect ; then
713     einfo "Detected Laptop - checking for PCMCIA." && eend 0
714     modprobe pcmcia_core >>$DEBUG 2>&1
715     # Try Cardbus or normal PCMCIA socket drivers
716     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
717     if [ "$?" = "0" ]; then
718       modprobe ds >>$DEBUG 2>&1
719       if [ -d /proc/bus/pccard ] ; then
720        if [ -x /sbin/cardmgr ] ; then
721         einfo "PCMCIA found, starting cardmgr."
722         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
723        else
724         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
725        fi
726       fi
727     fi
728   fi
729 fi
730 }
731 # }}}
732
733 # {{{ run software synthesizer via speakup
734 config_swspeak(){
735 if checkbootparam swspeak ; then
736  if [ -d /proc/speakup/ ] ; then
737   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
738   eindent
739    if [ -x /etc/init.d/speech-dispatcher ] ; then
740      einfo "Starting speech-dispatcher."
741      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
742      einfo "Activating sftsyn in Kernel."
743      echo sftsyn >/proc/speakup/synth_name ; eend $?
744      einfo "Just run swspeak if you want to use software synthesizer via speakup."
745      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
746    else
747     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
748     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
749    fi
750   eoutdent
751  else
752   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
753   flite -o play -t "Kernel does not seem to support speakup. Sorry."
754  fi
755 fi
756 }
757 # }}}
758
759 # {{{ Check for blind option or brltty
760 config_blind(){
761 BLIND=""
762 checkbootparam "blind" && BLIND="yes"
763 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
764
765 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
766   if [ -x /sbin/brltty ]; then
767     # Blind option detected, start brltty now.
768     # modprobe serial_core parport_serial generic_serial && echo "done"
769     CMD=brltty
770     BRLTYPE=""
771     BRLDEV=""
772     BRLTEXT=""
773     if [ -n "$BRLTTY" ]; then
774       # Extra options
775       BRLTYPE="${BRLTTY%%,*}"
776       R="${BRLTTY#*,}"
777       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
778         BRLTTY="$R"
779         BRLDEV="${BRLTTY%%,*}"
780         R="${BRLTTY#*,}"
781         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
782           BRLTTY="$R"
783           BRLTEXT="${BRLTTY%%,*}"
784           R="${BRLTTY#*,}"
785         fi
786       fi
787     fi
788     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
789     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
790     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
791     einfo "Starting braille-display manager."
792 #    ( exec $CMD & )
793     ( sh -c "$CMD" & )
794     sleep 2 && BLINDSOUND="yes"
795     eend 0
796   fi
797 fi
798 }
799 # }}}
800
801 # {{{ Interactive configuration
802 config_interactive(){
803 if [ -n "$INTERACTIVE" ] ; then
804 einfo "Entering interactive configuration second stage."
805
806   echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
807   echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
808   read a
809   [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
810
811   echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
812   read a
813   [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
814
815   echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
816   read a
817   [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
818   echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
819 fi
820 eend 0
821 }
822 # }}}
823
824 # {{{ AGP
825 config_agp(){
826 if checkbootparam forceagp ; then
827 # Probe for AGP. Hope this can fail safely
828   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
829 fi
830 }
831 # }}}
832
833 # {{{ automount(er)
834 config_automounter(){
835 if checkbootparam automounter ; then
836   RUNLEVEL="$(runlevel)"
837   AUTOMOUNTER=""
838   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
839
840 addautomount(){
841 # /dev/ice  options
842   d="${1##*/}"
843   if [ -n "$AUTOMOUNTER" ]; then
844     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
845     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
846     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
847     anew="$d        -fstype=auto,$2 :$i"
848     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
849     AUTOMOUNTS="$AUTOMOUNTS $d"
850     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
851   else
852     [ -d /mnt/$d ] && mkdir -p /mnt/$d
853     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
854   fi
855   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
856 }
857
858   AUTOMOUNTS="floppy cdrom"
859 # Add new devices to /etc/fstab and /etc/auto.mnt
860   for i in /dev/cdrom?*; do
861     if [ -L $i ]; then
862       addautomount "$i" "ro"
863     fi
864   done
865 fi
866
867 if [ -n "$AUTOMOUNTER" ]; then
868 # Check for floppy dir, reinstall with automounter
869   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
870   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
871   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
872   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
873   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
874   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
875   rm -f /etc/fstab.new
876 # Replace paths from bootfloppy
877   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
878   mv -f /etc/fstab.new /etc/fstab
879 # Start automounter now
880   einfo "Starting automounter for ${AUTOMOUNTS}."
881   /etc/init.d/autofs start >>$DEBUG ; eend $?
882 fi
883 }
884 # }}}
885
886 # {{{ Collect partitions from /proc/partitions first for enabling DMA
887 check_partitions(){
888 partitions=""
889 IDEDISKS=""
890 while read major minor blocks partition relax; do
891   partition="${partition##*/}"
892   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
893   case "$partition" in
894     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
895     sd?) ;;                                               # SCSI Harddisk, entire disk
896 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
897     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
898   esac
899 done <<EOT
900 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
901 EOT
902 }
903 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
904 # }}}
905
906 # {{{ Enable DMA for all IDE drives now if not disabled
907 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
908 config_dma(){
909 if checkbootparam "nodma"; then
910   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
911 else
912   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
913     if test -d /proc/ide/$d; then
914       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
915         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
916         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
917         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
918         echo "using_dma:1" >/proc/ide/$d/settings
919         eend 0
920       fi
921     fi
922   done
923 fi
924 }
925 # }}}
926
927 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
928 config_fstab(){
929
930 NOSWAP="yes" # we do not use swap by default!
931 if checkbootparam "swap" -o checkbootparam "anyswap" ; then
932    NOSWAP=''
933 fi
934
935 if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
936   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
937 else
938   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
939   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
940   iszsh && setopt nonomatch
941   if [ -x /usr/sbin/rebuildfstab ] ; then
942     config_userfstab || fstabuser=grml
943     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
944   else
945     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
946   fi
947   if [ -e /var/run/rebuildfstab.pid ]; then
948     # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
949     sleep 8
950   fi
951 fi
952 # Scan for swap, config, homedir
953 if [ -z "$NOSWAP" ]; then
954    einfo "Searching for swap partition(s) as requested."
955 fi
956 GRML_IMG=""
957 GRML_SWP=""
958 HOMEDIR="$(getbootparam home)"
959 if [ -n "$partitions" ]; then
960  while read p m f relax; do
961   case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
962   partoptions="users,exec"
963   fnew=""
964   case "$f" in swap)
965    eindent
966    if [ -n "$NOSWAP" ]; then
967     ewarn "Ignoring swap partition ${WHITE}$p${NORMAL} as requested." ; eend 0
968    else
969      case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
970              S1SUSP|S2SUSP|pmdisk|[zZ]*)
971                 if [ -n "$ANYSWAP" ] ; then
972                   einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
973                   swapon $p 2>>$DEBUG ; eend $?
974                 else
975                   ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
976                 fi
977                ;;
978              *)
979                 if [[ "$p" == LABEL* ]] ; then
980                    p=$(blkid -t $p | awk -F: '{print $1}')
981                 fi
982                 if grep -q $p /proc/swaps ; then
983                    ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
984                 else
985                    einfo "Using swap partition ${WHITE}${p}${NORMAL}."
986                    swapon $p 2>>$DEBUG ; eend $?
987                 fi
988                ;;
989      esac
990    fi
991    eoutdent
992    continue
993    ;;
994   esac
995 # Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
996 # Notice: grml-rebuildfstab >= 0.3-1 handles this now
997 #  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
998 #  [ -d "$m" ] || mkdir -p "$m"
999 # WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
1000   [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
1001   MOUNTOPTS="ro"
1002   case "$f" in
1003     vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1004     ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1005     *) continue ;;
1006     # *) NONEFOUND='1'; continue ;;
1007   esac
1008   mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
1009   # Activate swapfile, if exists
1010   SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1011   if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1012    mount -o remount,rw $m
1013    if swapon "$SWAPFILE" 2>>$DEBUG ; then
1014     einfo "Using GRML swapfile ${SWAPFILE}."
1015     fnew="$SWAPFILE swap swap defaults 0 0"
1016     stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1017     GRML_SWP="$GRML_SWP $SWAPFILE"
1018     eend 0
1019    fi
1020    mount -o remount,ro $m 2>>$DEBUG
1021   fi
1022   IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1023   if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1024    if [ -n "$HOMEDIR" ]; then
1025     if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1026      continue
1027     fi
1028    fi
1029    if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1030     GRML_IMG="$IMAGE"
1031     mount -o remount,ro $m 2>>$DEBUG
1032    fi
1033   fi
1034   eend 0
1035   # Umount, if not in use
1036   umount -r $m 2>/dev/null
1037  done <<EOT
1038 $(cat /etc/fstab)
1039 EOT
1040 fi
1041 }
1042 # }}}
1043
1044 # {{{ Mouse
1045 config_mouse(){
1046 if [ -n "$MOUSE_DEVICE" ] ; then
1047   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1048 fi
1049 }
1050 # }}}
1051
1052 # {{{ IPv6 configuration
1053 # Load IPv6 kernel module and print IP adresses
1054 config_ipv6(){
1055 if checkbootparam "ipv6"; then
1056   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1057   modprobe ipv6
1058   # we probably need some time until stateless autoconfiguration has happened
1059   sleep 2
1060   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1061   for DEVICE in `echo "$NETDEVICES"`
1062   do
1063     eindent
1064     einfo "$DEVICE:"
1065     ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1066     COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1067     eindent
1068     for ADDR in `echo "$ADDRESSES"`
1069     do
1070       einfo "$ADDR"
1071     done
1072     if [ "$COUNT" -eq "0" ]
1073     then
1074       einfo "(none)" ; eend 1
1075     fi
1076     eoutdent
1077     eoutdent
1078   done
1079   eend 0
1080 fi
1081 }
1082 # }}}
1083
1084 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1085 config_dhcp(){
1086 if checkbootparam "nodhcp"; then
1087   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1088 else
1089   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1090   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1091   for DEVICE in `echo "$NETDEVICES"` ; do
1092     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1093     trap 2 3 11
1094     ifconfig $DEVICE up >>$DEBUG 2>&1
1095     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1096     trap "" 2 3 11
1097     sleep 1
1098     eend 0
1099   done
1100 fi
1101 }
1102 # }}}
1103
1104 # {{{ helper functions
1105 findfile(){
1106 FOUND=""
1107 # search all partitions for a file in the root directory
1108 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1109 # See if it's already mounted
1110   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1111   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1112     [ -f "$i/$1" ] && FOUND="$i/$1"
1113     umount -l "$i" 2>>$DEBUG
1114     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1115   fi
1116 done
1117 return 2
1118 }
1119
1120 fstype(){
1121 case "$(file -s $1)" in
1122   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1123   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1124   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1125   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1126   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1127   *data*)          echo "invalid"; return 0;;
1128   *) echo "auto"; return 0;;
1129 esac
1130 }
1131
1132 # Try to mount this filesystem read-only, without or with encryption
1133 trymount(){
1134 # Check if already mounted
1135 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1136 # Apparently, mount-aes DOES autodetect AES loopback files.
1137 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1138 # We need to mount crypto-loop files with initial rw support
1139 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1140 # Mount succeeded?
1141 [ "$RC" = "0" ] && return 0
1142 echo ""
1143 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1144 a="y"
1145 while [ "$a" != "n" -a "$a" != "N" ]; do
1146 # We need to mount crypto-loop files with initial rw support
1147  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1148  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1149  # Problem with ioctl() from getpasswd()?
1150  # read a
1151  read a
1152 done
1153 return 1
1154 }
1155 # }}}
1156
1157 # {{{ CPU-detection
1158 config_cpu(){
1159 if checkbootparam "nocpu"; then
1160   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1161 else
1162   if ! [ -x /etc/init.d/powernowd ] ; then
1163     ewarn "Skipping CPU detection as powernowd dependencies are not fulfilled." ; eend 1
1164   elif [ ! -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] ; then
1165     ewarn "Skipping CPU detection as module dependencies are not fulfilled." ; eend 1
1166   else
1167     if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1168       einfo "Detecting CPU:"
1169       CPU=$(awk -F: '/^processor/{printf "      Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1170       echo $CPU | sed 's/ \{1,\}/ /g'
1171       eend 0
1172     else
1173       einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1174     fi
1175     if /usr/sbin/laptop-detect ; then
1176     einfo "Detected Laptop - trying to use cpu frequency scaling:"
1177 #      loadcpumod() {
1178 #      for module in /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq/*.ko /lib/modules/${KERNEL}/kernel/drivers/cpufreq/*.ko ; do
1179 #    # modprobe ${${${${(f)"$(_call_program modules ${(M)words[1]##*/}modprobe -l | grep cpufreq 2>>$DEBUG)"}:#}##*/}%.*}
1180 #        modprobe `basename ${module%%\.ko}` 1>>$DEBUG 2>&1
1181 #      done
1182 #      }
1183 #    CPU=$(grep 'model name' /proc/cpuinfo | cut -b14- | head -1)
1184 #    eindent
1185 #    if [[ $CPU = *Intel* ]] ; then
1186 #      einfo "Detected CPU is of type Intel - loading modules and starting cpudyn."
1187 #      local DETECTED=1
1188 #      loadcpumod
1189 #      /etc/init.d/cpudyn start 1>>$DEBUG ; eend $?
1190 #    fi
1191 #    if [[ $CPU = *AMD* ]] ; then
1192 #      einfo "Detected CPU is of type AMD - loading modules and starting powernowd."
1193 #      local DETECTED=1
1194 #      loadcpumod
1195 #      /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1196 #    fi
1197
1198      eindent
1199      if [ -r /usr/bin/cpufreq-detect.sh ] ; then
1200        . /usr/bin/cpufreq-detect.sh
1201        if [ -n "$MODULE" -a "$MODULE" != none ]; then
1202          einfo "Loading module ${MODULE} and starting powernowd."
1203          modprobe cpufreq_userspace 1>>$DEBUG
1204          modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1205          /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
1206        else
1207          ewarn "Could not detect an appropriate CPU for use with powernowd - skipping." && eend 1
1208        fi
1209      fi
1210      eoutdent
1211    fi
1212   fi
1213 fi
1214 }
1215 # }}}
1216
1217 # {{{ autostart of ssh
1218 config_ssh(){
1219 if checkbootparam ssh ; then
1220   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1221   einfo "Bootoption passwd found."
1222   if [ -n "$SSH_PASSWD" ] ; then
1223     echo "grml:$SSH_PASSWD" | chpasswd -m
1224     einfo "Starting secure shell server in background."
1225     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1226     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1227     eend 0
1228   else
1229     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1230   fi
1231   eindent
1232     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1233   eoutdent
1234 fi
1235 }
1236 # }}}
1237
1238 # {{{ set password for user grml
1239 config_passwd(){
1240 if checkbootparam passwd >>$DEBUG 2>&1; then
1241   einfo "Bootoption passwd found."
1242   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1243   if [ -n "$PASSWD" ] ; then
1244     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1245   else
1246     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1247   fi
1248   eindent
1249     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1250   eoutdent
1251 fi
1252 }
1253 # }}}
1254
1255 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1256 config_homedir(){
1257 HOMEDIR="$(getbootparam home)"
1258 MYHOMEDEVICE=""
1259 MYHOMEMOUNTPOINT=""
1260 MYHOMEDIR=""
1261 if [ -n "$HOMEDIR" ]; then
1262   einfo "Bootoption home detected." && eend 0
1263   case "$HOMEDIR" in
1264     /dev/*)
1265     MYHOMEDEVICE="${HOMEDIR##/dev/}"
1266     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1267     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1268     MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1269   ;;
1270     /mnt/*)
1271     MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1272     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1273     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1274     MYHOMEDIR="$HOMEDIR"
1275   ;;
1276     [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1277     MYHOMEDIR="$(findfile grml.img)"
1278     MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1279     MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1280     MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1281   ;;
1282   *)
1283     eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1284     eerror "Option ignored." ; eend 1
1285   ;;
1286   esac
1287 fi
1288
1289 if [ -n "$MYHOMEDIR" ]; then
1290   if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1291     [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1292     while read device mountpoint fs relax; do
1293       case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1294         case "$fs" in *[Nn][Tt][Ff][Ss]*)
1295           umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1296           break
1297         ;;
1298         *[Ff][Aa][Tt]*)
1299         # Note: This currently won't work with encrypted partitions
1300         umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1301         if [ ! -f "$MYHOMEDIR" ]; then
1302           ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1303           ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1304         fi
1305         ;;
1306       esac
1307       if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1308         einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1309         if [ -f "$MYHOMEDIR" ]; then
1310           # It's a loopback file, mount it over the /home/grml directory
1311           trymount "$MYHOMEDIR" /home/grml
1312           RC="$?"
1313           [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1314           RC="$?"
1315         else
1316           # Do a --bind mount
1317           ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1318           RC="$?"
1319         fi
1320         [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1321       fi
1322       break
1323       ;;
1324     esac
1325   done <<EOT
1326 $(cat /proc/mounts)
1327 EOT
1328   fi
1329 fi
1330 }
1331 # }}}
1332
1333 # {{{ Check for scripts on CD-ROM
1334 config_cdrom_scripts(){
1335 if checkbootparam "script"; then
1336   for script in /cdrom/scripts/* ; do
1337     einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1338     . $script
1339   done
1340 fi
1341 }
1342 # }}}
1343
1344 # {{{ Sound
1345 config_mixer(){
1346 if ! [ -x /usr/bin/aumix ] ; then
1347   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1348 else
1349
1350   if checkbootparam vol ; then
1351     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1352     if [ -z "$VOL" ] ; then
1353       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1354       VOL='75' # default
1355     fi
1356   else
1357     VOL='75' # default
1358   fi
1359
1360   if checkbootparam nosound ; then
1361     einfo "Muting sound devices on request."
1362     # some IBM notebooks require the following stuff:
1363     if [ -x /usr/bin/amixer ] ; then
1364        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1365           amixer set Front unmute 1>/dev/null
1366           amixer set Front 0% 1>/dev/null
1367        fi
1368     fi
1369     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1370     if [ -n "$ERROR" ] ; then
1371        eindent
1372        eerror "Problem muting sound devices: $ERROR"
1373        eoutdent
1374     fi
1375     eend $RC
1376   elif [ -z "$INSTALLED" ]; then
1377       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1378       # some IBM notebooks require the following stuff:
1379       if [ -x /usr/bin/amixer ] ; then
1380          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1381             amixer set Front unmute 1>/dev/null
1382             amixer set Front ${VOL}% 1>/dev/null
1383          fi
1384       fi
1385       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
1386       if [ -n "$ERROR" ] ; then
1387          eindent
1388          eerror "Problem setting mixer volumes: $ERROR"
1389          eoutdent
1390       fi
1391       eend $RC
1392   fi
1393
1394 fi
1395 }
1396 # }}}
1397
1398 # {{{ modem detection
1399 config_modem(){
1400 if checkbootparam "nomodem"; then
1401   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1402 else
1403   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1404    if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1405      einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
1406      /etc/init.d/sl-modem-daemon start >>$DEBUG &
1407      eend 0
1408    fi
1409   fi
1410 fi
1411 }
1412 # }}}
1413
1414 # {{{ keyboard add-ons
1415 config_setkeycodes(){
1416 if checkbootparam "setkeycodes" ; then
1417  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1418   # MS MM keyboard add-on
1419   # fix
1420   setkeycodes e001 126 &>/dev/null
1421   setkeycodes e059 127 &>/dev/null
1422   # fn keys
1423   setkeycodes e03b 59 &>/dev/null
1424   setkeycodes e008 60 &>/dev/null
1425   setkeycodes e007 61 &>/dev/null
1426   setkeycodes e03e 62 &>/dev/null
1427   setkeycodes e03f 63 &>/dev/null
1428   setkeycodes e040 64 &>/dev/null
1429   setkeycodes e041 65 &>/dev/null
1430   setkeycodes e042 66 &>/dev/null
1431   setkeycodes e043 67 &>/dev/null
1432   setkeycodes e023 68 &>/dev/null
1433   setkeycodes e057 87 &>/dev/null
1434   setkeycodes e058 88 &>/dev/null
1435   # hp keycodes
1436   setkeycodes e00a 89 e008 90 &>/dev/null
1437  eend 0
1438 fi
1439 }
1440 # }}}
1441
1442 # {{{ wondershaper
1443 config_wondershaper(){
1444  if checkbootparam "wondershaper" ; then
1445     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1446     CMD=wondershaper
1447     DEVICE=""
1448     DOWNSTREAM=""
1449     UPSTREAM=""
1450     if [ -n "$WONDER" ]; then
1451       # Extra options
1452       DEVICE="${WONDER%%,*}"
1453       R="${WONDER#*,}"
1454       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1455         WONDER="$R"
1456         DOWNSTREAM="${WONDER%%,*}"
1457         R="${WONDER#*,}"
1458         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1459           WONDER="$R"
1460           UPSTREAM="${WONDER%%,*}"
1461           R="${WONDER#*,}"
1462         fi
1463       fi
1464     fi
1465     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1466     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1467     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1468     einfo "Starting wondershaper (${CMD}) in background."
1469     ( sh -c $CMD & ) && eend 0
1470  fi
1471 }
1472 # }}}
1473
1474 # {{{ syslog-ng
1475 config_syslog(){
1476  if checkbootparam "nosyslog"; then
1477   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1478  else
1479   einfo "Starting syslog-ng in background."
1480   /etc/init.d/syslog-ng start 1>>$DEBUG &
1481   eend 0
1482  fi
1483 }
1484 # }}}
1485
1486 # {{{ gpm
1487 config_gpm(){
1488  if checkbootparam "nogpm"; then
1489   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1490  else
1491   einfo "Starting gpm in background."
1492 #  /etc/init.d/gpm start 1>>$DEBUG &
1493   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1494   eend 0
1495  fi
1496 }
1497 # }}}
1498
1499 # {{{ services
1500 config_services(){
1501  if checkbootparam "services" ; then
1502     SERVICE="$(getbootparam services 2>>$DEBUG)"
1503     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1504     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1505     einfo "Starting service(s) ${SERVICENL} in background."
1506     for service in $(echo -e $SERVICELIST) ; do
1507        /etc/init.d/${service} start 1>>$DEBUG &
1508     done
1509     [ "$?" == "0" ] ; eend $?
1510  fi
1511 }
1512 # }}}
1513
1514 # {{{ config files
1515 config_netconfig(){
1516  if checkbootparam netconfig ; then
1517   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1518   CONFIGFILE='/tmp/netconfig.grml'
1519
1520   getconfig() {
1521   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1522        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1523   }
1524   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1525   counter=10
1526   while ! getconfig && [[ "$counter" != 0 ]] ; do
1527     echo -n "Sleeping for 5 seconds and trying to get config again... "
1528     counter=$(( counter-1 ))
1529     echo "$counter tries left" ; sleep 1
1530   done
1531   if [ -r "$CONFIGFILE" ] ; then
1532     einfo "Downloading was successfull." ; eend 0
1533     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1534     md5sum $CONFIGFILE ; eend 0
1535     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1536   else
1537     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1538   fi
1539  fi
1540 }
1541 # }}}
1542
1543 # {{{ blindsound
1544 config_blindsound(){
1545  if checkbootparam "blind" ; then
1546     beep
1547     flite -o play -t "welcome to the gremel system"
1548  fi
1549 }
1550 # }}}
1551
1552 # {{{ welcome sound
1553 config_welcome(){
1554  if checkbootparam welcome ; then
1555   flite -o play -t "welcome to the gremel system"
1556  fi
1557 }
1558 # }}}
1559
1560 # {{{ fix/workaround for unionfs
1561 fix_unionfs(){
1562   if [ -z "$INSTALLED" ]; then
1563    touch /var/cache/apt/*cache.bin
1564   fi
1565 }
1566 # }}}
1567
1568 # {{{ create all /mnt-directories
1569 create_mnt_dirs(){
1570   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1571   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1572 }
1573 # }}}
1574
1575 # {{{ start X window system via grml-x
1576 config_x_startup(){
1577 if checkbootparam startx ; then
1578  if [ -x /usr/X11R6/bin/X ] ; then
1579   if [ -z "$INSTALLED" ] ; then
1580    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1581    if [ -z "$WINDOWMANAGER" ] ; then
1582      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1583      WINDOWMANAGER="wm-ng"
1584    else
1585      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1586    fi
1587    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1588    config_userfstab || fstabuser='grml'
1589  cat>|/etc/init.d/xstartup<<EOF
1590 #!/bin/sh
1591 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1592 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1593 EOF
1594    chmod 755 /etc/init.d/xstartup
1595    sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1596    sed -i 's#^6.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#'   /etc/inittab
1597    /sbin/telinit q ; eend $?
1598   else
1599     eerror "We are not running from CD - startx will not work, skipping it.
1600      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1601   fi
1602  else
1603    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1604    Boot parameter startx does not work therefore." ; eend 1
1605  fi
1606 fi
1607 }
1608 # }}}
1609
1610 # {{{ configuration framework
1611 config_extract(){
1612 if checkbootparam extract ; then
1613  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1614  EXTRACTOPTIONS="-- -x $EXTRACT"
1615 fi
1616 }
1617
1618 config_automount(){
1619 if checkbootparam noautoconfig -o checkbootparam forensic ; then
1620   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1621 else
1622  if [ -z "$INSTALLED" ] ; then
1623   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1624   eindent
1625   [ -d /mnt/grml ] || mkdir /mnt/grml
1626   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1627 # We do need the following fix so floppy disk is available to blkid in any case :-/
1628   if [ -r /dev/fd0 ] ; then
1629      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1630 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1631      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1632         blkid /dev/fd0 1>>$DEBUG 2>&1
1633      fi
1634   fi
1635   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1636   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1637   if [[ $RC == 0 ]]; then
1638     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1639
1640     CONFIG=''
1641     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1642     if [ -n "$CONFIG" ]; then
1643       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1644       cd /
1645       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1646     else
1647       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1648     fi
1649
1650     SCRIPT=''
1651     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1652     if [ -n "$SCRIPT" ]; then
1653       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1654       $SCRIPT ; eend $?
1655     fi
1656     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1657   else
1658     ewarn "No devices with label GRMLCFG found." ; eend 0
1659   fi
1660   eoutdent
1661  fi
1662 fi
1663 }
1664
1665 config_myconfig(){
1666
1667 if checkbootparam "config" ; then
1668   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1669   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1670   einfo "Bootoption config found. config is set to: $CONFIG"
1671   eindent
1672     einfo "Trying to extract configuration file ${CONFIG}:"
1673     cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1674   eoutdent
1675 fi
1676
1677 if checkbootparam myconfig ; then
1678  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1679  if [ -n "$MOUNTDEVICE" ]; then
1680    if checkbootparam file ; then
1681     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1682     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1683    fi
1684    [ -d /mnt/grml ] || mkdir /mnt/grml
1685    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1686    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1687     if [[ $RC == 0 ]]; then
1688       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1689       eindent
1690       CONFIG=''
1691       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1692       if [ -n "$CONFIG" ]; then
1693         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1694         cd /
1695         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1696       else
1697         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1698       fi
1699
1700       SCRIPT=''
1701       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1702       if [ -n "$SCRIPT" ]; then
1703         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1704         $SCRIPT ; eend $?
1705       fi
1706       eoutdent
1707     else
1708       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1709     fi # mount $MOUNTDEVICE
1710    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1711  else
1712    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1713  fi # [ -n "$MOUNTDEVICE" ]
1714 fi # checkbootparam myconfig
1715
1716 if checkbootparam "partconf" ; then
1717  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1718  if [ -n "$MOUNTDEVICE" ]; then
1719    [ -d /mnt/grml ] || mkdir /mnt/grml
1720    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1721     if [[ $RC == 0 ]]; then
1722       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1723       einfo "Copying files from $MOUNTDEVICE over grml system."
1724       for file in `cat /etc/grml/partconf` ; do
1725         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1726         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1727       done && eend 0
1728     else
1729       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1730     fi # mount $MOUNTDEVICE
1731    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1732  else
1733    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1734  fi # [ -n "$MOUNTDEVICE" ]
1735 fi
1736 }
1737 # }}}
1738
1739 # {{{ /cdrom/.*-options
1740 config_debs(){
1741 if checkbootparam "debs" ; then
1742   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1743   einfo "Tring to install debian package(s) ${DEBS}"
1744   dpkg -i /cdrom/debs/$DEBS* ; eend $?
1745 fi
1746 }
1747
1748 config_scripts(){
1749 if checkbootparam "scripts" ; then
1750   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1751   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1752   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1753   sh -c /cdrom/scripts/$SCRIPTS ; eend $?
1754 fi
1755 }
1756 # }}}
1757
1758 # {{{ distcc
1759 config_distcc(){
1760 if checkbootparam "distcc" ; then
1761  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1762  if [ -n "$OPTIONS" ]; then
1763     NET=""
1764     INTERFACE=""
1765     if [ -n "$OPTIONS" ]; then
1766       NET="${OPTIONS%%,*}"
1767       R="${OPTIONS#*,}"
1768       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1769         OPTIONS="$R"
1770         INTERFACE="${OPTIONS%%,*}"
1771         R="${OPTIONS#*,}"
1772       fi
1773     fi
1774  fi
1775  CONFIG=/etc/default/distcc
1776  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1777  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1778
1779  if [ -n "$INTERFACE" ] ; then
1780    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1781
1782    counter=10
1783    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1784      counter=$(( counter-1 ))
1785      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1786      sleep 3
1787      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1788    done
1789  fi
1790
1791  if [ -n "$IP" ] ; then
1792    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1793
1794    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1795    eindent
1796     id distccd >/dev/null 2>&1 || \
1797     (
1798       einfo "Creating distcc user" ; \
1799       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1800     )
1801
1802     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1803    /etc/init.d/distcc start 1>/dev/null ; eend $?
1804    eoutdent
1805  else
1806    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1807  fi
1808 fi
1809
1810 if checkbootparam "gcc"; then
1811  GCC="$(getbootparam gcc 2>>$DEBUG)"
1812  eindent
1813  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1814  eoutdent
1815  rm -f /usr/bin/gcc
1816  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1817 fi
1818
1819 if checkbootparam "gpp"; then
1820  GPP="$(getbootparam gpp 2>>$DEBUG)"
1821  eindent
1822   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1823   if [ -x /usr/bin/g++-${GPP} ] ; then
1824      rm -f /usr/bin/g++
1825      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1826   fi
1827   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1828   if [ -x /usr/bin/cpp-${GPP} ] ; then
1829      rm -f /usr/bin/cpp
1830      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1831   fi
1832  eoutdent
1833 fi
1834
1835 }
1836 # }}}
1837
1838 # {{{ load modules
1839 # Notice: use it only on live-cd system, if running from harddisk please
1840 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
1841 # in /etc/runlevel.conf
1842 config_modules(){
1843 MODULES_FILE=/etc/grml/modules
1844 if checkbootparam nomodules ; then
1845   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
1846 elif [ -z "$INSTALLED" ]; then
1847  if [ -r $MODULES_FILE ] ; then
1848   einfo "Loading modules specified in ${MODULES_FILE}:"
1849   eindent
1850   grep '^[^#]' $MODULES_FILE | \
1851   while read module args; do
1852     [ "$module" ] || continue
1853       einfo "${module}"
1854       modprobe $module $args ; eend $?
1855   done
1856   eoutdent
1857  else
1858   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
1859  fi
1860 fi
1861 }
1862 # }}}
1863
1864 # {{{ 915resolution
1865 config_915resolution(){
1866 if checkbootparam "915resolution" ; then
1867  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
1868   if [ -x /usr/sbin/915resolution ]; then
1869     CMD=915resolution
1870     MODE=""
1871     XRESO=""
1872     YRESO=""
1873     if [ -n "$OPTIONS" ]; then
1874       # Extra options
1875       MODE="${OPTIONS%%,*}"
1876       R="${OPTIONS#*,}"
1877       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1878         OPTIONS="$R"
1879         XRESO="${OPTIONS%%,*}"
1880         R="${OPTIONS#*,}"
1881         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1882           OPTIONS="$R"
1883           YRESO="${OPTIONS%%,*}"
1884           R="${OPTIONS#*,}"
1885         fi
1886       fi
1887     fi
1888     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
1889     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
1890     eend 0
1891   fi
1892 fi
1893 }
1894 # }}}
1895
1896 # {{{ SW-RAID
1897 config_swraid(){
1898   if [ -z "$INSTALLED" ] ; then
1899   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
1900   if checkbootparam "noraid" -o checkbootparam "forensic" -o checkbootparam "raid=noautodetect" ; then
1901      ewarn "Skipping search for SW-RAID as requested on boot commandline." ; eend 0
1902   else
1903     if ! [ -x /sbin/mdadm ] ; then
1904        eerror "mdadm not available, can not execute it." ; eend 1
1905     else
1906
1907        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1908        # find out whether we have a valid configuration file already
1909        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
1910           einfo "Creating /etc/mdadm/mdadm.conf"
1911           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
1912           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
1913         else
1914           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
1915        fi
1916
1917        einfo "Searching for software RAID arrays (disable via bootoption noraid):"
1918        eindent
1919          IFSOLD=${IFS:-}
1920          IFS='
1921 '
1922          for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
1923              case $line in
1924                *'No arrays found'*)
1925                  ewarn "$line" ; eend 0
1926                  ;;
1927                *)
1928                  einfo "$line" ; eend 0
1929                  ;;
1930              esac
1931          done
1932          IFS=$IFSOLD
1933        eoutdent
1934
1935        if [ -r /proc/mdstat ] ; then
1936           eindent
1937           MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
1938           if [ -z "$MDSTAT" ] ; then
1939              ewarn "No active arrays found" ; eend 0
1940           else
1941              IFSOLD=${IFS:-}
1942              IFS='
1943 '
1944              for line in $(grep '^md[0-9]' /proc/mdstat) ; do
1945                  einfo "active arrays: $line" ; eend 0
1946              done
1947              IFS=$IFSOLD
1948           fi
1949           eoutdent
1950        fi
1951
1952      fi # is /sbin/mdadm executable?
1953   fi # check for bootoptions
1954   fi # run only in live-cd mode
1955 }
1956 # }}}
1957
1958 # {{{ debnet: setup network based on an existing one found on a partition
1959 config_debnet(){
1960 if checkbootparam "debnet" ; then
1961  iszsh && setopt shwordsplit
1962  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
1963  DEVICES="$DEVICES $(ls /dev/mapper/*)"
1964  FOUND_DEBNET=""
1965
1966  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
1967  eindent
1968  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
1969     for i in $DEVICES; do
1970      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
1971          einfo "Scanning on $i"
1972        if [ -f /mnt/etc/network/interfaces ]; then
1973          einfo "/etc/network/interfaces found on ${i}" ; eend 0
1974          FOUND_DEBNET="$i"
1975          break
1976        fi
1977        umount /mnt
1978      fi
1979     done
1980
1981    if [ -n "$FOUND_DEBNET" ]; then
1982      einfo "Stopping network."
1983        pump -k 1>/dev/null 2>&1
1984        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
1985      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
1986        rm -rf /etc/network/run
1987        cp -a /mnt/etc/network /etc
1988        rm -rf /etc/network/run
1989        mkdir /etc/network/run
1990        umount /mnt ; eend $?
1991      einfo "Starting network."
1992        /etc/init.d/networking start ; eend $?
1993    else
1994      eerror "/etc/network/interfaces not found." ; eend 1
1995    fi
1996    eoutdent
1997  else
1998   eerror "Error: /mnt already mounted." ; eend 1
1999  fi
2000 fi
2001 }
2002 # }}}
2003
2004 # {{{ disable console blanking
2005 config_blanking(){
2006 if checkbootparam "noblank" ; then
2007   einfo "Bootoption noblank found. Disabling monitor blanking."
2008   setterm -blank 0 ; eend $?
2009 fi
2010 }
2011 # }}}
2012
2013 # {{{ grml2hd: automatic installation
2014 config_grml2hd(){
2015
2016 if checkbootparam "user" ; then
2017   NEWUSER=''
2018   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2019   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2020 fi
2021
2022 if checkbootparam "filesystem" ; then
2023   FILESYSTEM=''
2024   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2025   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2026 fi
2027
2028 if checkbootparam "partition" ; then
2029   PARTITION=''
2030   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2031   # notice: the following checks whether the given partition is available, if not the skip
2032   # execution of grml2hd as it might result in data loss...
2033   if [ -r $PARTITION ] ; then
2034     sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2035   else
2036     ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2037   fi
2038 fi
2039
2040 if checkbootparam "mbr" ; then
2041   BOOT_PARTITION=''
2042   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2043   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2044 fi
2045
2046 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2047   cat>|/usr/bin/grml2hd_noninteractive<<EOF
2048 #!/bin/sh
2049 GRML2HD_NONINTERACTIVE='yes' grml2hd
2050 EOF
2051   chmod 755 /usr/bin/grml2hd_noninteractive
2052   einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2053   if [ -z "$GRML2HD_FAIL" ] ; then
2054     screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2055   else
2056     ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2057   fi
2058 fi
2059 }
2060 # }}}
2061
2062 ### {{{ backwards compatible stuff
2063 config_environment(){
2064   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2065 }
2066 config_keyboard(){
2067   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2068 }
2069 # }}}
2070
2071 ## END OF FILE #################################################################
2072 # vim:foldmethod=marker